#ifndef _STDARG_H
#define _STDARG_H

#ifdef __x86_64__

#ifdef __TINYC__

/* only correct for TCC & x86-64.
   Also, this lacks the support of aggregated types. */

typedef struct {
    int reg;
    int sse;
    int stack;
    char *fp;
} va_list;

#define va_start(ap, last)                                              \
    (ap = (*(va_list*)((char*)__builtin_frame_pointer(0) - 16)),        \
     ap.fp = (char*)__builtin_frame_pointer(0))
#define va_arg(ap, type)                                                \
    (*(type*)(__builtin_types_compatible_p(type, long double)           \
              ? (ap.stack += 16,                                        \
                 (ap.fp + ap.stack - 16))                               \
              : __builtin_types_compatible_p(type, double)              \
              ? (ap.sse < 8                                             \
                 ? (ap.fp - 80 + ap.sse++ * 8)                          \
                 : (ap.stack += 8,                                      \
                    (ap.fp + ap.stack - 8)))                            \
              : (ap.reg < 6                                             \
                 ? (ap.fp - 128 + ap.reg++ * 8)                         \
                 : (ap.stack += 8,                                      \
                    (ap.fp + ap.stack - 8)))                            \
        ))
#define va_copy(dest, src) (dest) = (src)
#define va_end(ap)

#else

/* for GNU C */

typedef __builtin_va_list va_list;

#define va_start(ap, last) __builtin_va_start(ap, last)
#define va_arg(ap, type) __builtin_va_arg(ap, type)
#define va_copy(dest, src) __builtin_va_copy(dest, src)
#define va_end(ap) __builtin_va_end(ap)

#endif

#else

typedef char *va_list;

/* only correct for i386 */
#define va_start(ap,last) ap = ((char *)&(last)) + ((sizeof(last)+3)&~3)
#define va_arg(ap,type) (ap += (sizeof(type)+3)&~3, *(type *)(ap - ((sizeof(type)+3)&~3)))
#define va_copy(dest, src) (dest) = (src)
#define va_end(ap)

#endif

/* fix a buggy dependency on GCC in libio.h */
typedef va_list __gnuc_va_list;
#define _VA_LIST_DEFINED

#endif /* _STDARG_H */
